      SUBROUTINE EC02C(AR,AI,GR,GI,N1,N2,D1,D2,ALP,P,L,H,FR,FI)
         INTEGER L,N1,N2
         REAL AI,ALP,AR,D1,D2,FI,FR,GI,GR,H,P
         DIMENSION AI(N1,N2),AR(N1,N2),FI(N1,N2),FR(N1,N2),GI(N1,N2),
     1             GR(N1,N2),H(4)
         INTEGER I,J,N3,N4,N5,N6
         REAL B,C,C1,DW1,DW2,Q,R,R1,R2,R3,R4,R5,R6,R7,R8,S1,S2,S3,
     1        SYS003,W1,W2
         DATA SYS003/6.283185/
       GO TO (10,30,30,20),L
   10  CONTINUE
       Q = 1.
       CALL FTFTC(AR,AI,N1,N2,Q)
   20  CONTINUE
       Q = 1.
       CALL FTFTC(GR,GI,N1,N2,Q)
       GO TO 120
   30  CONTINUE
       N3 = N1/2 + 1
       N4 = N2/2 + 1
       N5 = N1 + 1
       N6 = N2 + 1
       B = 1./(N1*N2)
       C1 = D1*D2
       C = 1./C1
       DW1 = SYS003/(N1*D1)
       DW2 = SYS003/(N2*D2)
       Q = ALP*C*C
       S1 = 0.
       S2 = 0.
       S3 = 0.
       DO 90 I = 1, N1
          IF (I .GT. N3) GO TO 40
             W1 = DW1*(I - 1)
             GO TO 50
   40     CONTINUE
          W1 = DW1*(N5 - I)
   50     CONTINUE
          DO 80 J = 1, N2
             IF (J .GT. N4) GO TO 60
                W2 = DW2*(J - 1)
                GO TO 70
   60        CONTINUE
             W2 = DW2*(N6 - J)
   70        CONTINUE
             R1 = AR(I,J)
             R2 = AI(I,J)
             R3 = GR(I,J)
             R4 = GI(I,J)
             R5 = R1*R1 + R2*R2
             IF (W1 .EQ. 0. .AND. W2 .EQ. 0. .AND. P .EQ. 0.)
     1          W2 = 1.
             R = 1. + (W1*W1 + W2*W2)**P
             R6 = 1./(R5 + Q*R)
             R7 = ((R1*R3 + R2*R4)*C)*R6
             R8 = ((R1*R4 - R2*R3)*C)*R6
             FR(I,J) = R7
             FI(I,J) = R8
             R3 = C1*(R1*R7 - R2*R8) - R3
             R4 = C1*(R1*R8 + R2*R7) - R4
             S1 = S1 + R3*R3 + R4*R4
             R3 = (R*B)*(R7*R7 + R8*R8)
             S2 = S2 + R3
             R4 = R*((ALP*R6)*R)*(ALP*R6)*R3
             S3 = S3 + R4
   80     CONTINUE
   90  CONTINUE
       H(1) = SQRT(S1*C1*B)
       H(2) = SQRT(S2*C1)
       H(3) = SQRT(H(1)*H(1) + ALP*H(2)*H(2))
       H(4) = SQRT(S3*C)*C
       IF (L .EQ. 3) GO TO 120
          S1 = 1.
          DO 110 I = 1, N1
             S1 = -S1
             DO 100 J = 1, N2
                S1 = -S1
                FR(I,J) = FR(I,J)*S1*B
                FI(I,J) = FI(I,J)*S1*B
  100        CONTINUE
  110     CONTINUE
          Q = -1.
          CALL FTFTC(FR,FI,N1,N2,Q)
  120  RETURN
      END
